<?php
/**
 * Plugin Authentification CAS
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-nd
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/cookie');

// http://doc.spip.org/@action_logout_dist
function action_logout_dist()
{
    global $visiteur_session, $ignore_auth_http;
    $logout =_request('logout');
    $url = _request('url');
    // cas particulier, logout dans l'espace public
    if ($logout == 'public' AND !$url)
        $url = url_de_base();

//------- Debut ajout CI -----
    include_spip('inc/eolecas_commun');

    // lire la configuration du plugin
    eolecas_lire_meta();

    $ciauthcas= false;
    if ($GLOBALS['ciconfig']['eolecas']=="oui" OR isset($_COOKIE['eolecas_sso'])) {
        if ($GLOBALS['ciconfig']['eolecasurldefaut'])
            $ciauthcas= true;
    }
//------- Fin ajout CI -----

    // seul le loge peut se deloger (mais id_auteur peut valoir 0 apres une restauration avortee)
    if (is_numeric($visiteur_session['id_auteur'])) {
        include_spip('inc/auth');
        auth_trace($visiteur_session, '0000-00-00 00:00:00');
    // le logout explicite vaut destruction de toutes les sessions
            $session = charger_fonction('session', 'inc');
            $session($visiteur_session['id_auteur']);
            setcookie('spip_session', $_COOKIE['spip_session'], time()-3600);

        // si authentification http, et que la personne est loge,
        // pour se deconnecter, il faut proposer un nouveau formulaire de connexion http
        if (isset($_SERVER['PHP_AUTH_USER']) AND !$ignore_auth_http AND $GLOBALS['auth_can_disconnect']) {
            include_spip('inc/actions');
              ask_php_auth(_T('login_deconnexion_ok'),
                       _T('login_verifiez_navigateur'),
                       _T('login_retour_public'),
                        "redirect=". _DIR_RESTREINT_ABS,
                       _T('login_test_navigateur'),
                       true);

        }
//------- Debut ajout CI -----
        if ($ciauthcas) {

            // import phpCAS lib
            include_once("configCAS/cas.inc.php");
            include_once('CAS-1.3.1/eoleCAS.php');
            define('__CAS_URL', "");

            // Pour la solution hybride utilisation d'un cookie
                setcookie('eolecas_sso', '', time() - 3600);

            // initialize phpCAS
            EolephpCAS::client(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,"",false);
            EolephpCAS::setNoCasServerValidation();
            $url = str_replace('index.php', 'index.php', $_SERVER['SCRIPT_URI']);

            // deconnexion de CAS avec l'url retour
            EolephpCAS::logout(array("url" => $url));

            /* if (method_exists(EolephpCAS,'logoutWithUrl')) { */
            /*  // Compatibilit avec les versions rcentes de phpCAS */
            /*  EolephpCAS::logoutWithUrl($url); */
            /* } else { */
            /*  EolephpCAS::logout($url); */
            /* } */

        }
//------- Fin ajout CI -----

    }

//------- Debut ajout CI -----
    if (!$ciauthcas) {
//------- Fin ajout CI -----
        // Rediriger en contrant le cache navigateur (Safari3)
        include_spip('inc/headers');
        redirige_par_entete($url
            ? parametre_url($url, 'var_hasard', uniqid(rand()), '&')
            : generer_url_public('login'));
//------- Debut ajout CI -----
    }
//------- Fin ajout CI -----
}

?>
