<?php
/**
 * Plugin Authentification CAS
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-nd
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/config');
include_spip('inc/eolecas_commun');

function configuration_eolecas_configuration()
{
	// lire la configuration du plugin
	$ciedit = eolecas_lire_meta();

	$eolecas = $GLOBALS['ciconfig']['eolecas'];
	$eolecasurldefaut = $GLOBALS['ciconfig']['eolecasurldefaut'];
	$eolecasrepertoire = $GLOBALS['ciconfig']['eolecasrepertoire'];
	$eolecasuid = $GLOBALS['ciconfig']['eolecasuid'];
	$eolecasport = $GLOBALS['ciconfig']['eolecasport'];

	$action = generer_url_ecrire('eolecas_config');

	$res .= "<form action='$action' method='post'>".form_hidden($action)
	. "<input type='hidden' name='changer_config' value='oui' />";

	$res .= "<br />"._T('eolecas:eq_avertissement')."<br />";

	$res .= "<br />\n"
	. debut_cadre_relief("", true, "", _T('eolecas:eq_titre_mode_auth'))
	. "<table border='0' cellspacing='1' cellpadding='3' width=\"100%\">";


    // eolecas
	$res .= "\n<tr><td class='verdana2'>"
	. eolecas_afficher_choix('eolecas', $eolecas,
		array('oui' => _T('eolecas:eq_texte_auth_cas'),
			'hybride' => _T('eolecas:eq_texte_auth_hybride'),
			'non' => _T('eolecas:eq_texte_auth_spip')), " &nbsp; ", !$ciedit)
	. "</td></tr>\n";

	$res .= "\n</table>"
	. fin_cadre_relief(true);

	$res .= "<br />\n"
	. debut_cadre_relief("", true, "", _T('eolecas:eq_titre_serveur_cas'))
	. "<table border='0' cellspacing='1' cellpadding='3' width=\"100%\">";

    // eolecasurldefaut
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='eolecasurldefaut'>"._T('eolecas:eq_texte_url')."</label><br />"
	. " <input type='text' name='eolecasurldefaut' id='eolecasurldefaut' value=\"$eolecasurldefaut\" size='40' class='formo' ".($ciedit ? "" : "disabled='disabled'"). "/><br />"
	. "</td></tr>";

    // eolecasrepertoire
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='eolecasrepertoire'>"._T('eolecas:eq_texte_repertoire')."</label><br />"
	. " <input type='text' name='eolecasrepertoire' id='eolecasrepertoire' value=\"$eolecasrepertoire\" size='40' class='formo' ".($ciedit ? "" : "disabled='disabled'"). " /><br />"
	. "</td></tr>";

    // eolecasport
	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='eolecasport'>"._T('eolecas:eq_texte_port')."</label><br />"
	. " <input type='text' name='eolecasport' id='eolecasport' value=\"$eolecasport\" size='40' class='formo' ".($ciedit ? "" : "disabled='disabled'"). "/><br />"
	. "</td></tr>";

    // eolecasuid
    $ci_tableau_uid = array("email" => "email", "login" => "login");
    if (!$eolecasuid)
    	$eolecasuid = "email";

	$res .= "\n<tr><td class='verdana2'>"
	. "<label for='eolecasuid'>"._T('eolecas:eq_texte_uid')."</label><br />"
    . "\n<select name='eolecasuid' class='formo' ".($ciedit ? "" : "disabled='disabled'"). ">\n"
    . "<option value='$eolecasuid' selected='selected'>".$ci_tableau_uid[$eolecasuid]."</option>\n";

	foreach ($ci_tableau_uid as $cle => $valeur) {
	if ($cle <> $eolecasuid)
		$res .= "<option value='$cle'>".$valeur."</option>\n";
	}

    $res .= "</select><br />\n";
	$res .= "</td></tr>"
	. "\n</table>";

	$res .= fin_cadre_relief(true);


	$res .= '<span><input type="submit" class="fondo" style="float: right;" value="Valider"/></span>'
	. "</form>";

	$res = debut_cadre_trait_couleur("", true, "", _T('eolecas:eq_titre'))
	. $res
	. fin_cadre_trait_couleur(true);

	return $res;

}

function eolecas_afficher_choix($nom, $valeur_actuelle, $valeurs, $sep = "<br />", $disabled = false) {
	$choix = array();
	while (list($valeur, $titre) = each($valeurs)) {
		$choix[] = eolecas_bouton_radio($nom, $valeur, $titre, $valeur == $valeur_actuelle, $disabled);
	}
	return "\n".join($sep, $choix);
}

function eolecas_bouton_radio($nom, $valeur, $titre, $actif = false, $disabled = false) {
	static $id_label = 0;

	if ($disabled) $option = " disabled='disabled'";
	else $option = "";

	$texte = "<input type='radio' name='$nom' value='$valeur' id='label_${nom}_${id_label}'$option";
	if ($actif) {
		$texte .= ' checked="checked"';
		$titre = '<b>'.$titre.'</b>';
	}
	$texte .= " /> <label for='label_${nom}_${id_label}'>$titre</label>\n";
	$id_label++;
	return $texte;
}


?>
